;****************    ***************

  errorlevel 0, -302
; 
; RA0     - IN  Pm
; RA1     - IN  Temp (analog)
; RA2     - IN  Gabar
; RA3     - IN  MCLR
; RA4     - IN  Pow1
; RA5     - IN  Pow2
; RC0     - OUT . 
; RC1     - OUT 
; RC2     - OUT LED
; RC2-RC5 - OUT=0 

;*************************************
         LIST    p=16F630
         INCLUDE p16f630.inc
;                           PWRTE on
;                           MCLR on| WDT on
;                       BG        || |
        __CONFIG 31ECH; 11.0001.1110.1100
;                             | ||    --- INT osc RA4,RA5-IN/OUT
;                             | |BOD inable
;                       CPD off CP off

;*************************************
;    16F676
ADCON0      equ  1FH   ;  ADC
ANSEL       equ  91H   ; //
;*************************************

;    CurIn:
BIT_Temp    equ  0  ; =1 - T>
BIT_Pm      equ  1  ; =1 - P>
BIT_Gabar   equ  2  ; =1 - . .
BIT_Pow     equ  3  ; =1 - . . 1  2
Maska_Pow   equ  08H; 0000.1000
Maska_Pm    equ  02H; 0000.0010

;    CurOut:
BIT_SvetOn  equ  0  ; =1 -  
BIT_Signal  equ  1  ; =1 -  
BIT_Led     equ  2  ; =1 - . LED
Maska_Out   equ  07H  ; 0000.0111

BIT_SndT    equ  5  ; =1 -  T
BIT_SndPow  equ  6  ; =1 -  Pow
BIT_SndSvet equ  7  ; =1 -  Svet
Maska_Svet  equ  0E0H ; 1110.0000
Maska_Test  equ  20H  ; 0010.0000

; 
Gist         equ  20H    ;   Pm  Temp
ConstT1      equ  .1000  ; *4ms = 4s -   .  T
ConstT2      equ  .256   ; *4ms = 1s - .  T
ConstT3      equ  .6250  ; *4ms = 25s -   
ConstPow     equ  .8     ; *4ms = 32ms - . . Pow
ConstTOUTP   equ  .1000  ; *4ms = 4s - TOUT  Pow
ConstIngOFF  equ  .3     ; *4ms = 12ms -   . .
ConstIngON   equ  .1000  ; *4ms = 4s -   . .
ConstOFF     equ  .256   ; *4ms = 1s -   . . . 
ConstSigSvet equ  .750   ; *4ms = 3s - .  
NPow         equ  .2     ; -  . -1
NnotPow      equ  .17    ;  . . . -1

CALIBR       equ   0A6H  ;  

;  
  cblock  20H ;    
TmpInt1       ;  .
TmpInt2       ; //
Maslo         ; //    . 
Temper        ; //   . .
csa           ; //  . 
cva           ; //
count_A       ; //
count_B       ; //
count_C       ; //
CurIn         ; // . . 
CurOut        ; //   PORTC
RTCHi         ; //  . TMR1
RTCLow        ; ////
StateT        ;   T
CntTHi        ;   T
CntTLow       ; /
StatePow      ;   Pow
CntPowHi      ;   Pow
CntPowLow     ; /
CntNPow       ;  
CurInOld      ;  . 
StateFr       ;   Fari
CntFrHi       ;   Fary
CntFrLow      ; /

TMPHi
TMPLow
TMP1Hi
TMP1Low

  endc        ;  
;*************************************

            ORG     0000H
            goto    INIT

            ORG     0004H
; /  
            movwf   TmpInt1       ; . W
            swapf   STATUS,W
            movwf   TmpInt2       ; . STATUS
            bcf     STATUS,RP0    ; 0 .
            btfss   INTCON,T0IF   ; . TMR0
            goto    $             ;  TMR0, ,  WDT
;  TMR0
            bcf     INTCON,T0IF
            incf    RTCLow,F      ;  .
            btfsc   STATUS,Z
            incf    RTCHi,F
;  
            btfss   CMCON,COUT    ; T>
            goto    TempOK        ; T<
            incf    Temper,F
            btfsc   STATUS,Z
            comf    Temper,F      ; =00,  =FF
            goto    RdPm
TempOK:     decf    Temper,F      ; -1
            comf    Temper,W
            btfsc   STATUS,Z
            movwf   Temper        ; =FF,  =00
;  
RdPm:       movlw   10H
            btfss   PORTA,0       ; P>
            goto    PmMin         ; P<
            addwf   Maslo,W       ; +10H
            btfss   STATUS,C      ; ,  
            movwf   Maslo  
            goto    RdIn
PmMin:      subwf   Maslo,W       ; -10H
            btfsc   STATUS,C      ; ,  
            movwf   Maslo
;  ,
; 0,0,Pow2,Pow1,0,Gabar,0,x
RdIn:       movf    PORTA,W
            movwf   csa
            rrf     csa,W         ; Pow2 >>
            xorwf   csa,W         ; Pow1 xorwf Pow2
            andlw   10H           ; 000x.0000  Pow
            bcf     csa,4
            btfss   STATUS,Z
            bsf     csa,4         ; ,  . 1 .
;  
            MOVF    count_C,W
            XORWF   count_B,F
            XORWF   count_B,W
            ANDWF   count_C,W
            XORWF   count_A,F
            COMF    count_C,F
            MOVF    count_C,W
            ANDWF   count_A,W
            IORWF   count_B,F
            MOVF    csa,W
            XORWF   cva,W
            ANDWF   count_C,F
            ANDWF   count_B,F
            ANDWF   count_A,F
            MOVF    count_C,W
            IORWF   count_B,W
            IORWF   count_A,W
            ANDWF   cva,F
            XORLW   0xff
            ANDWF   csa,W
            IORWF   cva,F           ; . 
;   
; CurIn=x,x,x,x,Pow,Gabar,Pm,Temp
            movlw   (80H+Gist)
            subwf   Temper,W        ; Temper-(80H+Gist)
            btfsc   STATUS,C        ; Temper < (80H+Gist)
            bsf     CurIn,BIT_Temp  ; Temper >= (80H+Gist)
            movlw   (80H-Gist)
            subwf   Temper,W        ; Temper-(80H-Gist)
            btfss   STATUS,C        ; Temper >= (80H-Gist)
            bcf     CurIn,BIT_Temp  ; Temper < (80H-Gist)
;
            movlw   (80H+Gist)
            subwf   Maslo,W         ; Maslo-(80H+Gist)
            btfsc   STATUS,C        ; Maslo < (80H+Gist)
            bsf     CurIn,BIT_Pm    ; Maslo >= (80H+Gist)
            movlw   (80H-Gist)
            subwf   Maslo,W         ; Maslo-(80H-Gist)
            btfss   STATUS,C        ; Maslo >= (80H-Gist)
            bcf     CurIn,BIT_Pm    ; Maslo < (80H-Gist)
;
            bcf     CurIn,BIT_Gabar ; Gabar
            btfsc   cva,2
            bsf     CurIn,BIT_Gabar
            bcf     CurIn,BIT_Pow   ; Pow
            btfsc   cva,4
            bsf     CurIn,BIT_Pow
;  
            bcf     CurOut,BIT_Signal
            movf    CurOut,W
            andlw   Maska_Svet      ; xxx0.0000
            btfss   STATUS,Z        ;  .
            bsf     CurOut,BIT_Signal
            bcf     CurOut,BIT_Led
            btfsc   CMCON,COUT      ; T<
            bsf     CurOut,BIT_Led  ; . 
            movf    CurOut,W
            andlw   Maska_Out       ; 0000.0xxx
            movwf   PORTC
;
            swapf   TmpInt2,W
            movwf   STATUS        ; . STATUS
            swapf   TmpInt1,F
            swapf   TmpInt1,W     ; . W,   STATUS
            retfie

;************   ********
;  16F630

INIT:       clrwdt
            clrf   STATUS
            clrf   INTCON         ;  .
            clrf   PCLATH
            clrf   PORTA
            clrf   PORTC
            clrf   ADCON0         ; . ADC
            clrf   T1CON          ; TMR1 off
            movlw  04H            ; 0000.0100, COUT=1 Vin-<Vin+
            movwf  CMCON          ; RA1 - analog
            bsf    STATUS,RP0
            movlw  0D3H           ; 1101.0011 PullUp-dis,
            movwf  OPTION_REG     ; Presc-TMR0 1/16 = 4ms
            movlw  3FH            ; 0011.1111
            movwf  TRISA          ; PORTA -IN
            clrf   TRISC          ; PORTC - OUT
            clrf   WPUA           ; PullUp-dis
            clrf   PIE1           ;  .
            call   03FFH
            movwf  OSCCAL         ;  
            movlw  02H
            movwf  ANSEL          ; RA1 - analog (16F676)
            clrf   IOCA           ;  . on change
            movlw  0A5H           ; Vref = 5*5/24=~1,04V
            movwf  VRCON          ; Vref - on
            clrf   EECON1         ; . EEPROM
            bcf    STATUS,RP0
            movlw  20H            ; 0010.0000
            movwf  INTCON         ; . . TMR0,  .
;  20H-5FH
            movlw  20H
            movwf  FSR
ClrMem:     clrf   INDF
            incf   FSR,F
            movf   FSR,W
            xorlw  60H
            btfss  STATUS,Z
            goto   ClrMem
            clrf   TMR0
            bcf    INTCON,T0IF    ;   . TMR0
            bsf    INTCON,GIE     ; . .
;  
Begin:      clrwdt
            btfss  CurIn,BIT_Pm   ;  
            goto   StTOK          ; , T  
; *************  T ***************
            movf   StateT,F
            btfss  STATUS,Z       ; StateT=0
            goto   StT1
            btfss  CurIn,BIT_Temp ; T>
            goto   StTOK          ; T - OK
            call   RdRTC          ;  RTC
            call   MovTMP_CntT    ;  RTC CntT
            incf   StateT,F       ; . .
            goto   StPow
;   .
StT1:       movf   StateT,W
            xorlw  01H
            btfss  STATUS,Z       ; StateT=1
            goto   StT2
            call   RdRTC          ;  RTC  TMPHi,TMPLow
            call   MovCntT_TMP1
            call   Sub2b          ; Cnt-RTC
            movlw  HIGH (ConstT1)
            movwf  TMP1Hi
            movlw  LOW (ConstT1)
            movwf  TMP1Low
            call   Sub2b          ; (Cnt-RTC)-ConstT1
            btfss  STATUS,C       ;  
            goto   StPow          ;  , 
            bsf    CurOut,BIT_SndT;  
            call   RdRTC          ;  RTC  TMPHi,TMPLow
            call   MovTMP_CntT
            incf   StateT,F       ; . .
            goto   StPow
; . .
StT2:       movf   StateT,W
            xorlw  02H
            btfss  STATUS,Z       ; StateT=2
            goto   StT3
            call   RdRTC          ;  RTC  TMPHi,TMPLow
            call   MovCntT_TMP1
            call   Sub2b          ; Cnt-RTC
            movlw  HIGH (ConstT2)
            movwf  TMP1Hi
            movlw  LOW (ConstT2)
            movwf  TMP1Low
            call   Sub2b          ; (Cnt-RTC)-ConstT2
            btfss  STATUS,C       ;  
            goto   StPow          ;  , 
            bcf    CurOut,BIT_SndT;  
            call   RdRTC          ;  RTC  TMPHi,TMPLow
            call   MovTMP_CntT    ;  RTC  CntT
            incf   StateT,F       ; . .
            goto   StPow
;   .
StT3:       movf   StateT,W
            xorlw  03H
            btfss  STATUS,Z       ; StateT=3
            goto   StTOK          ; StateT>=4
            call   RdRTC          ;  RTC  TMPHi,TMPLow
            call   MovCntT_TMP1
            call   Sub2b          ; Cnt-RTC
            movlw  HIGH (ConstT3)
            movwf  TMP1Hi
            movlw  LOW (ConstT3)
            movwf  TMP1Low
            call   Sub2b          ; (Cnt-RTC)-ConstT3
            btfss  STATUS,C       ;  
            goto   StPow          ;  , 
StTOK:      clrf   StateT
            bcf    CurOut,BIT_SndT;    . .

; ***********  Pow ***************
StPow:      movf   StatePow,W
            btfss  STATUS,Z       ; StatePow=0
            goto   StPow1
            movf   CurIn,W
            andlw  Maska_Pow      ; 0000.x000
            btfsc  STATUS,Z       ; <>0
            goto   StFari         ;   . 
            call   RdRTC          ;  RTC
            call   MovTMP_CntPow  ;  RTC  CntPow
            movf   CntNPow,W      ;  
            sublw  NPow           ; NPow-CntNPw
            btfsc  STATUS,C       ; CntNPow>NPow   
            bsf    CurOut,BIT_SndPow ;  
            incf   StatePow,F     ; . .
            goto   StFari
StPow1:     movf   StatePow,W
            xorlw  01H
            btfss  STATUS,Z       ; StatePow=1
            goto   StPow2
;. 
            call   RdRTC          ;  RTC  TMPHi,TMPLow
            call   MovCntPow_TMP1
            call   Sub2b          ; Cnt-RTC
            movlw  HIGH (ConstPow)
            movwf  TMP1Hi
            movlw  LOW (ConstPow)
            movwf  TMP1Low
            call   Sub2b          ; (Cnt-RTC)-ConstPow
            btfss  STATUS,C       ;  
            goto   StFari       ;  , 
            bcf    CurOut,BIT_SndPow;  
            incf   CntNPow,F      ;  
            incf   StatePow,F     ; . .
            goto   StFari
;  .  .
StPow2:     movf   StatePow,W
            xorlw  02H
            btfss  STATUS,Z       ; StatePow=2
            goto   StPow3
            movf   CurIn,W
            andlw  Maska_Pow      ; 0000.x000
            btfss  STATUS,Z       ; =0
            goto   StFari
            incf   StatePow,F     ;  .
            call   RdRTC          ;  RTC  TMPHi,TMPLow
            call   MovTMP_CntPow  ;  RTC
            goto   StFari
;  .   TOUT
StPow3:     movf   StatePow,W
            xorlw  03H
            btfss  STATUS,Z       ; StatePow=3
            goto   StPow4         ; StatePow>=4
            movf   CurIn,W
            andlw  Maska_Pow      ; 0000.x000
            btfsc  STATUS,Z       ; <>0
            goto   StPow33        ; 
            movf   CntNPow,W      ;  
            sublw  NnotPow        ; NnotPow-CntNPw
            btfsc  STATUS,C       ; CntNPow>NPow
            goto   StPow31
            clrf   CntNPow        ;   .
StPow31:    clrf   StatePow
            goto   StFari
; 
StPow33:    call   RdRTC          ;  RTC  TMPHi,TMPLow
            call   MovCntPow_TMP1
            call   Sub2b          ; Cnt-RTC
            movlw  HIGH (ConstTOUTP)
            movwf  TMP1Hi
            movlw  LOW (ConstTOUTP)
            movwf  TMP1Low
            call   Sub2b          ; (Cnt-RTC)-ConstTOUTP
            btfss  STATUS,C       ;  
            goto   StFari         ;  , 
            clrf   StatePow       ;  
            clrf   CntNPow
            goto   StFari
StPow4:     clrf   StatePow       ;   
            clrf   CntNPow
            bcf    CurOut,BIT_SndPow;  

; *********   **************
StFari:     movf   CurIn,W        ; . . 
            xorwf  CurInOld,W     ;  ., =1
            movwf  TMPHi          ; 
            comf   CurInOld,W
            andwf  TMPHi,W        ; _| = 1
            andlw  Maska_Pm
            btfss  STATUS,Z
            goto   Pusk           ;  .
            movf   CurInOld,W
            andwf  TMPHi,W        ; |_ = 1
            andlw  Maska_Pm
            btfss  STATUS,Z
            goto   Stop           ;  .
            movf   StateFr,W
            btfss  STATUS,Z       ; StateFr=00
            goto   StFr1
; State=0 . .,  ,  
            bcf    CurOut,BIT_SndSvet ; . 
            bcf    CurOut,BIT_SvetOn  ; . 
            goto   Begin
StFr1:      movf   StateFr,W
            xorlw  01H
            btfss  STATUS,Z       ; StateFr=01
            goto   StFr2          ; StateFr>=2
; State=1 
            call   RdRTC          ;  RTC  TMPHi,TMPLow
            call   MovCntFr_TMP1  ; . . RTC  TMP1Hi,TMP1Low
            call   Sub2b          ; Cnt-RTC (TMP-TMP1)-->TMP
            movlw  HIGH (ConstIngON)
            movwf  TMP1Hi
            movlw  LOW (ConstIngON)
            movwf  TMP1Low
            call   Sub2b          ; (Cnt-RTC)-ConstIng
            btfsc  STATUS,C       ; 
            incf   StateFr,F      ;  , StateFr=2
            goto   Begin
StFr2:      movf   StateFr,W
            xorlw  02H
            btfss  STATUS,Z       ; StateFr=02
            goto   StFr3          ; StateFr>=3
; State=2 
            bsf    CurOut,BIT_SvetOn  ; . 
            bcf    CurOut,BIT_SndSvet ; . 
            goto   Begin
StFr3:      movf   StateFr,W
            xorlw  03H
            btfss  STATUS,Z       ; StateFr=03
            goto   StFr4          ; StateFr>=4
; State=3 
            call   RdRTC          ;  RTC  TMPHi,TMPLow
            call   MovCntFr_TMP1
            call   Sub2b          ; Cnt-RTC
            movlw  HIGH (ConstIngOFF)
            movwf  TMP1Hi
            movlw  LOW (ConstIngOFF)
            movwf  TMP1Low
            call   Sub2b          ; (Cnt-RTC)-ConstIngOFF
            btfss  STATUS,C       ;  
            goto   Begin          ; 
            incf   StateFr,F      ; StateFr=4
            call   RdRTC          ;  RTC
            call   MovTMP_CntFr   ;  RTC  CntFr
            bcf    CurOut,BIT_SvetOn  ; . 
            goto   Begin
StFr4:      movf   StateFr,W
            xorlw  04H
            btfss  STATUS,Z       ; StateFr=04
            goto   StFr5          ; StateFr>=5
; State=4 , .  . 
            call   RdRTC          ;  RTC  TMPHi,TMPLow
            call   MovCntFr_TMP1
            call   Sub2b          ; Cnt-RTC
            movlw  HIGH (ConstOFF)
            movwf  TMP1Hi
            movlw  LOW (ConstOFF)
            movwf  TMP1Low
            call   Sub2b          ; (Cnt-RTC)-ConstOFF
            btfss  STATUS,C       ;  
            goto   Begin          ; 
            incf   StateFr,F      ; StateFr=5
            call   RdRTC          ;  RTC
            call   MovTMP_CntFr   ;  RTC  CntFr
            btfsc  CurIn,BIT_Gabar;  
            bsf    CurOut,BIT_SndSvet ; ,  
            goto   Begin
; State=5 , . 
StFr5:      call   RdRTC          ;  RTC  TMPHi,TMPLow
            call   MovCntFr_TMP1
            call   Sub2b          ; Cnt-RTC
            movlw  HIGH (ConstSigSvet)
            movwf  TMP1Hi
            movlw  LOW (ConstSigSvet)
            movwf  TMP1Low
            call   Sub2b          ; (Cnt-RTC)-ConstSigSvet
            btfsc  STATUS,C       ; 
            clrf   StateFr        ;  , StateFr=0
            goto   Begin
;  .
Pusk:       bcf    CurOut,BIT_SndSvet ;  
            movlw  01H
            goto   PuskStop
;  .
Stop:       movlw  03H
PuskStop:   movwf  StateFr
            movf   CurIn,W            ;  
            movwf  CurInOld
            call   RdRTC              ;  RTC
            call   MovTMP_CntFr       ;  RTC  CntFr
            goto   Begin              ;  

; ***************** / **************
; /  RTC
; : TMPHi,TMPLow
RdRTC:      movf   RTCHi,W        ;  RTC
            movwf  TMPHi
            movf   RTCLow,W
            movwf  TMPLow
            movf   RTCHi,W
            xorwf  TMPHi,W
            btfss  STATUS,Z
            goto   RdRTC          ; , 
            return

; /  (TMPHi,TMPLow) - (TMP1Hi,TMP1Low)
; : TMPHi,TMPLow   - 1- 
;      TMP1Hi,TMP1Low - 2-  ( )
; : TMPHi,TMPLow
;       .  .
;       1-  < 2-, C=0
Sub2b:      MOVF   TMP1Low,W      ; .  2- 
            SUBWF  TMPLow,F       ;  . 
            MOVF   TMP1Hi,W       ; . 2 
            BTFSS  STATUS,C
            INCFSZ TMP1Hi,W       ;   (=0)
            SUBWF  TMPHi,F        ;    (=1)
            RETURN

; /  TMP  CntT
MovTMP_CntT:
            movf   TMPHi,W        ;  RTC
            movwf  CntTHi
            movf   TMPLow,W
            movwf  CntTLow
            return

; /  CntT  TMP1
MovCntT_TMP1:
            movf   CntTHi,W
            movwf  TMP1Hi
            movf   CntTLow,W
            movwf  TMP1Low
            return

; /  TMP  CntPow
MovTMP_CntPow:
            movf   TMPHi,W        ;  RTC
            movwf  CntPowHi
            movf   TMPLow,W
            movwf  CntPowLow
            return

; /  CntPow  TMP1
MovCntPow_TMP1:
            movf   CntPowHi,W
            movwf  TMP1Hi
            movf   CntPowLow,W
            movwf  TMP1Low
            return

; /  TMP  CntFr
MovTMP_CntFr:
            movf   TMPHi,W        ;  RTC
            movwf  CntFrHi
            movf   TMPLow,W
            movwf  CntFrLow
            return

; /  CntFr  TMP1
MovCntFr_TMP1:
            movf   CntFrHi,W
            movwf  TMP1Hi
            movf   CntFrLow,W
            movwf  TMP1Low
            return

            ORG    03FFH
            retlw  CALIBR           ;  

            end
